<template>
  <div class="box">
    <div class="condition">
      <div class="header">
        <el-button style="float:left;" size="small" type="default" icon="el-icon-back" @click="goBack"></el-button>
        <span>{{ params.Name }}</span>
      </div>
      <el-row class="spaceTypes">
        <div class="types">
          <el-tabs v-model="activeTab" type='card'>
            <template v-for="(item,index) in tabsList">
              <el-tab-pane :name="item.Code" :key="index" :label="item.Name"></el-tab-pane>
            </template>
          </el-tabs>
        </div>
        <div class="deleBtn">
          <el-button size="small" @click="deleteSystem">删除系统</el-button>
        </div>
      </el-row>
      <div v-if="activeTab=='detail'" class="content">
        <el-scrollbar style="height:100%;">
          <div class="content-scrollbar">
            <div class="content-left">
              <div class="content-showType">
                <selectRadio
                  :selectRadio="selectRadio"
                  @changeRadio="changeRadio"
                />
              </div>
              <div class="content-point">
                <div class="content-point-left">
                  <exhibitionBaseInformation :exhibitionBaseInformation="exhibitionBaseInformation"/>
                </div>
              </div>
            </div>
            <div class="content-right">
              <div class="content-repair">
                <exhibitionMaintain :exhibitionMaintain="exhibitionMaintain"/>
              </div>
              <div class="content-media">
                <exhibitionImage :exhibitionImage="exhibitionImage" v-show="isShowImage"/>
                <exhibitionVideo :exhibitionVideo="exhibitionVideo" v-show="isShowVideo"/>
                <exhibitionFile :exhibitionFile="exhibitionFile" v-show="isShowFile"/>
              </div>
            </div>
          </div>
        </el-scrollbar>
      </div>
      <!-- 系统内设备 -->
      <deviceTable v-if="activeTab=='Equipment'" :params="params" :type="activeTab"></deviceTable>
      <!-- 系统所在竖井 -->
      <cenoteTable v-else-if="activeTab=='cenote'" :params="params" :type="activeTab"></cenoteTable>
      <!-- 系统所在业务空间 -->
      <spaceTable v-else-if="activeTab=='space'" :params="params" :type="activeTab" :spaceType="spaceType"
                  :floorType="floorType"></spaceTable>
    </div>
  </div>
</template>

<script>
import { mapGetters } from "vuex";
import { deleteGeneralSys, queryLinkSys } from '@/api/scan/request';
import { getDataDictionary, queryPhysicsAllType } from "@/api/dict";
import { buildingQuery } from '@/api/object/build';
import cenoteTable from '@/components/ledger/system/table/cenoteTable';
import deviceTable from '@/components/ledger/system/table/deviceTable';
import spaceTable from '@/components/ledger/system/table/spaceTable';
import exhibitionBaseInformation from "@/components/ledger/details/detail/exhibitionBaseInformation";
import exhibitionFile from "@/components/ledger/details/detail/exhibitionFile";
import exhibitionImage from "@/components/ledger/details/detail/exhibitionImage";
import selectRadio from "@/components/ledger/details/detail/selectRadio";
import exhibitionMaintain from "@/components/ledger/details/detail/exhibitionMaintain";
import exhibitionVideo from "@/components/ledger/details/detail/exhibitionVideo";
import tools from "@/utils/scan/tools"


export default {
  data() {
    return {
      params: {}, //参数-包含系统id 分区类型
      tabsList: [
        { Code: 'detail', Name: '系统详情' },
        { Code: 'Equipment', Name: '系统内设备' },
        { Code: 'cenote', Name: '系统所在竖井' },
        { Code: 'space', Name: '系统所在业务空间' },
      ], //tab页
      activeTab: 'detail', //当前选中的tab
      pointData: [], //信息点数据
      exampleData: {}, //实例数据
      spaceType: {},//空间种类
      floorType: {},
      currentRadio: '1',//当前选中的select
      selectRadio: {
        information: '设备信息点',
        initRadio: '1',
        radioList: [
          {
            value: '显示需采集信息点',
            label: '1'
          },
          {
            value: '显示有值信息点',
            label: '2'
          },
          {
            value: '显示全部信息点',
            label: '3'
          }
        ]
      },
      exhibitionBaseInformation: {
        information: {}
      },
      exhibitionEnergy: {
        title: '能耗信息',
        dynamic: [],
      },
      exhibitionMaintain: {
        title: '维修/维保记录'
      },
      exhibitionFile: {
        title: '文件',
        list: {}
      },
      exhibitionCrux: {
        title: '关键信息点：',
        cruxArray: [],
        allMessage: [],//全部信息点
      },
      exhibitionImage: {
        title: '图片',
        list: {},
        arr: []
      },
      exhibitionVideo: {
        title: '视频',
        list: {}
      },
      instance: {},//实例信息处理
      isShowImage: true,
      isShowVideo: true,
      isShowFile: true,
    }
  },
  computed: {
    ...mapGetters("layout", ["projectId", "userId", "secret"])
  },
  components: {
    cenoteTable,
    deviceTable,
    spaceTable,
    exhibitionBaseInformation,
    exhibitionFile,
    exhibitionImage,
    selectRadio,
    exhibitionMaintain,
    exhibitionVideo
  },
  created() {
    this.params = this.$route.query;
    this.getData();

    let pa = {
      type: `space`
    }
    // queryDictionaryHead(pa, res => {
    queryPhysicsAllType(pa, res => {
      res.content.map(t => {
        if (t.name != "元空间") {
          this.spaceType[t.code] = t.name;
        }
      })
    });

    let param = {
      cascade: [
        { name: "floor" }
      ]
    };
    buildingQuery(param, res => {
      res.content.map(item => {
        if (item.id && item.localName) {
          this.floorType[item.id] = item.localName;
          if (item.floor instanceof Array) {
            item.floor.map(f => {
              if (f.id && f.localName) {
                this.floorType[f.id] = f.localName;
              }
            })
          }
        }
      });
    });

  },
  mounted() {
  },
  watch: {
    projectId() {
    }
  },
  methods: {
    // 返回
    goBack() {
      this.$router.push({
        name: "systemlist",
        params: this.params
      })
    },
    // 获取表头和实例数据
    getData() {
      let params1 = {
        orders: "sort asc",
        pageNumber: 1,
        pageSize: 1000,
        type: this.params.SysType
      }, params2 = {
        filters: `id='${this.params.SysID}'`,
      };
      let promise1 = new Promise((resolve, reject) => {
        getDataDictionary(params1, res => {
          resolve(res)
        })
      })
      let promise2 = new Promise((resolve, reject) => {
        queryLinkSys(params2, res => {
          resolve(res)
        })
      })
      Promise.all([promise1, promise2]).then(values => {
        this.pointData = values[0].content;
        this.exampleData = values[1].content[0];
        let obj = this.deepCopy(values[1].content[0]);
        obj = tools.flattenKeys(obj);
        for (let key in obj) {
          if (Array.isArray(obj[key]) && !obj[key].length) {
            delete obj[key]
          }
        }
        this.instance = obj;
        this.handleRadios(this.currentRadio)
        this.handleEnclosure() //处理图片视频文件信息
      })
    },
    deepCopy(obj) {
      return JSON.parse(JSON.stringify(obj))
    },
    handleEnclosure() {
      //图片文件处理，脱离radio控制
      let isList = this.pointData
      let isArr = []
      isList.map(j => {
        if (this.instance.hasOwnProperty(j.path)) {
          j.value = this.instance[j.path]
          return j
        }
      })
      isArr = isList.filter(k => k.value)
      this.handlePicList(isArr)
      this.handleFileList(isArr)
    },
    handleRadios(val) { //判断radio的值显示关键信息，基本信息，图片，文件
      let arr = []
      if (val == 1) { //需采集信息
        arr = this.pointData.filter(i => i.visible)
        //  图片和的处理
        // this.handlePicList(arr)
        // //  文件处理
        // this.handleFileList(arr)

      } else if (val == 2) { //有值信息点
        let list = this.pointData
        list.map(j => {
          if (this.instance.hasOwnProperty(j.path)) {
            return {
              ...j,
              value: this.instance[j.path]
            }
          }
          arr = list.filter(k => k.value)
          // this.handlePicList(arr)
          // this.handleFileList(arr)
        })
      } else { //全部信息点
        arr = this.pointData
        // this.handlePicList(arr)
        // this.handleFileList(arr)
      }
      this.displayData(arr)
    },
    handlePicList(arr) {
      let picObject = {}
      //处理数据格式
      arr.map(i => {
        if (i.dataType == 'ATTACHMENT') {
          switch (i.Path) {
            case 'infos.drawing':
            case 'infos.installPic':
            case 'infos.installDrawing':
            case 'infos.nameplate':
            case 'infos.pic':
              if (this.instance.hasOwnProperty(i.path)) {
                i.PicList = this.instance[i.path]
              }
              if (picObject[i.name]) {

              } else {
                picObject[i.name] = []
              }
              picObject[i.name].push({
                ...i,
              })
              break;

          }
        }

      })
      //展示图片
      this.exhibitionImage.list = picObject
      let isArray = [] //获取图片数组
      for (let i in picObject) {
        if (Array.isArray(picObject[i])) {
          let list = picObject[i]
          list.forEach(i => {
            if (i.PicList) {
              isArray.push(...i.PicList)
            }
          })
        }
      }
      this.exhibitionImage.arr = isArray
      let video = isArray.filter(i => i.Type != 'image' && i.type != 'image')
      this.exhibitionVideo.list = video
      //判断是否显示图片组件
      this.isShowImage = isArray.length ? true : false
      //判断是否显示video组件
      this.isShowVideo = video.length ? true : false
    },
    handleFileList(arr) {
      let picObject = {}
      //处理数据格式
      arr.map(i => {
        if (i.dataType == 'ATTACHMENT') {
          switch (i.Path) {
            case 'infos.insuranceFile':
            case 'infos.archive':
            case 'infos.checkReport':
              if (this.instance.hasOwnProperty(i.path)) {
                i.fileList = this.instance[i.path]
              }
              if (picObject[i.name]) {

              } else {
                picObject[i.name] = []
              }

              picObject[i.name].push({
                ...i,
              })
              break
          }
        }

      })
      //展示文件
      this.exhibitionFile.list = picObject
      let isArray = [] //获取文件数组
      for (let i in picObject) {
        if (Array.isArray(picObject[i])) {
          let list = picObject[i]
          list.forEach(i => {
            if (i.fileList) {
              isArray.push(...i.fileList)
            }
          })
        }
      }
      //判断是否显示文件组件
      this.isShowFile = isArray.length ? true : false
    },
    changeRadio(val) { //1,需采集，2，有值，3，全部
      this.handleRadios(val)
      this.currentRadio = val
    },
    formatDate(str) {
      if (str) {
        if (str.includes('-')) {
          return str
        } else {
          if (str.length > 8) {
            return str.substr(0, 4) + "-" + str.substr(4, 2) + "-" + str.substr(6, 2) + " " + str.substr(8, 2) + ":" + str.substr(10, 2) + ":" + str.substr(12, 2)
          } else {
            return str.substr(0, 4) + "-" + str.substr(4, 2) + "-" + str.substr(6, 2) + " " + str.substr(8, 2)
          }
        }
      } else {
        return '--'
      }
    },
    displayData(arr) {//对数据进行处理传给组件展示
      const result = {}
      arr.forEach(i => {
        if (this.instance.hasOwnProperty(i.path) && this.currentRadio != 2) {
          i.value = this.instance[i.path]
        }
        if (i.dataType == 'DATETIME') {
          if (this.instance.hasOwnProperty(i.path)) {
            let time = this.instance[i.path]
            i.value = this.formatDate(time)
          }
        }
        if (i.dataSource && i.dataSource.length) {
          // let source = JSON.parse(i.DataSource)
          let source = i.dataSource
          //判断输入类型
          if (i.dataType == 'ENUM') {
            let d1l = tools.formatDataSource(i.dataSource)
            d1l.forEach(k => {
              if (k.code == this.instance[i.path]) {
                i.value = k.name
              }
            })
          } else if (i.dataType == 'MENUM' || i.dataType == 'DATETIME') {
            if (this.instance.hasOwnProperty(i.path)) {
              if (!Array.isArray(this.instance[i.path])) {
                let transArray = this.instance[i.path].split(',')
                i.value = source.filter(item => transArray.includes(item.code)).map(item => item.name).join(',')
              }
            }
          }
          source.forEach(j => {
            if (j.code == this.instance[i.path]) {
              i.value = j.name
            }
          })
        }
        switch (i.category) {
          case "STATIC":
            if (result[`${i.firstName}${i.secondName ? '/' + i.secondName : ''}`]) {
              result[`${i.firstName}${i.secondName ? '/' + i.secondName : ''}`].paths.push({
                Path: i.Path,
                InfoPointName: i.name,
                InfoPointCode: i.code,
                Value: i.value,
                Visible: i.visible,
                KeyWord: i.keyWord,
                data: i.data,
                receivetime: i.receivetime,
                error: i.error,
                Unit: i.unit,
                FirstName: i.firstName,
                classCode: i.classCode,
                id: i.id,
                groupCode: i.groupCode,
                type: i.type,
                dataType: i.dataType
              })
            } else {
              result[`${i.firstName}${i.secondName ? '/' + i.secondName : ''}`] = {
                paths: [{
                  Path: i.path,
                  InfoPointName: i.name,
                  InfoPointCode: i.code,
                  Value: i.value,
                  Visible: i.visible,
                  KeyWord: i.keyWord,
                  data: i.data,
                  receivetime: i.receivetime,
                  error: i.error,
                  Unit: i.unit,
                  FirstName: i.firstName,
                  classCode: i.classCode,
                  id: i.id,
                  groupCode: i.groupCode,
                  type: i.type,
                  dataType: i.dataType
                }]
              }
            }
            break
        }
      })
      this.exhibitionBaseInformation.information = result
      this.exhibitionCrux.allMessage = result
    },
    // 删除系统
    deleteSystem() {
      this.$confirm("此操作将删除系统，是否继续？", "提示", {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        let pa = [{
          id: this.exampleData.id
        }]
        this.removeSys(pa)
      }).catch(() => {
        this.$message("取消删除")
      })
    },
    async removeSys(param) {
      await deleteGeneralSys(param, res => {
        this.$message.success("删除成功")
        this.goBack()
      })
    },
  }
};
</script>

<style scoped lang='less'>
@bgc: #fff;
.box {
  .condition {
    padding: 10px;
    display: flex;
    height: 100%;
    flex-direction: column;
    border: 1px solid #dfe6ec;
    background: #fff;
    box-sizing: border-box;

    .header {
      padding-bottom: 10px;

      span {
        line-height: 33px;
        margin-left: 15px;
      }
    }

    .spaceTypes {
      .types {
        float: left;
        width: calc(100% - 200px);

        /deep/ .el-tabs__item.is-top {
          border-top: 2px solid transparent;

          &.is-active {
            border-top: 2px solid #409eff;
          }
        }
      }

      .deleBtn {
        float: left;
        width: 200px;
        text-align: right;
        height: 40px;
        border-bottom: 1px solid #e4e7ed;
      }
    }

    .content {
      height: calc(100% - 99px);

      .content-scrollbar {
        display: flex;
        height: 100%;
        flex-direction: row;
        box-sizing: border-box;
        background-color: @bgc;

        .content-left {
          display: flex;
          flex-direction: column;
          flex: 1;

          .content-showType {
            height: 50px;
            border: 1px solid #ccc;
            border-bottom: none;
            box-sizing: border-box;
            background: @bgc;
          }

          .content-point {
            display: flex;
            flex-direction: row;
            border: 1px solid #ccc;
            box-sizing: border-box;
            background: @bgc;

            .content-point-left {
              flex: 1;
            }
          }
        }

        .content-right {
          width: 400px;
          margin-left: 10px;
          box-sizing: border-box;

          .content-repair {
            height: 50px;
            line-height: 50px;
            margin-bottom: 10px;
            border: 1px solid #ccc;
            background: @bgc;
            box-sizing: border-box;
          }

          .content-media {
            box-sizing: border-box;
          }
        }
      }
    }

    .main {
      margin-top: 10px;
      height: calc(100% - 96px);
    }

    .footer {
      margin-bottom: 10px;
    }

    /deep/ .el-scrollbar__wrap {
      overflow-x: hidden;
    }
  }
}
</style>

<style lang="less">
.el-table th {
  background-color: #d9d9d9;
  color: #000;
}
</style>

